.TH SEARCHMONKEY 1 "September 12, 2006"
.SH NAME
SEARCHMONKEY \- search files using regular expressions aiming to
replace find/grep tools
.SH INTRODUCTION
\fBsearchMonkey\fP is a GTK+ application designed to replace the find/grep
command line tools.
The aim of this utility it to provide fast, slick text search ability
to the GTK community. 
.SH The User Interface
This section describes every button, window, table and what it shows
or does. 
.PP \fBThe Main-Menu\fP
.SS 
.SS File Menu
.SS
.TP
.B New			
Starts a brand new search (losing previous search history).
.TP
.B Open Criteria
Opens a previously saved search criteria.
.TP
.B Close
Close a child criteria window, but not the main application.
.TP
.B Save Criteria		
Saves a search criteria (excluding the results).
.B Save Criteria As	
As Save Criteria, but brings up a save-as dialog.
.TP
.B Save Results		
Saves the results to a custom XML file. Only available
when search complete.
.TP
.B Print			
Print the search results in a well formatted way.
.TP
.B Print Preview		
Brings up a display of what would have been printed.
.TP
.B Print Setup		
Brings up the system's printer setup dialog.
.SS 
.SS Edit Menu
.SS
.TP
.B Word Wrap	 
When selected, allow the results text to wrap instead of keeping to
strict lines.
.TP
.B Set Font	
Brings up a font dialog to adjust the results window base font.
.TP
.B Set Color	
Brings up a color selection dialog to adjust the highlight colour for
the match results.
.TP
.B Clear History	
Remove search history from drop down criteria.
.TP
.B Select All	
Selects all file name matches in the left results pane.
.TP
.B Delete	
Deletes the selected file name(s) forever (once confirmed).
.TP
.B Copy	
Copies the selected file name(s) to clipboard.
.SS
.SS  View Menu
.SS
.TP
.B Toolbar	 
If selected, the tool bar is shown.
.TP
.B Status Bar	
If selected, the status bar is shown.
.TP
.B Sort by		
Within sub-menu, choose sort criteria e.g. file name, file size,
modified date.
.SS
.SS  Search Menu
.SS
.TP 
.B Start	 
Starts the search.
.TP
.B Stop	
Stops the search. Enabled when search is running.
.TP
.B One phase searching	
Allows content matches to be displayed immediately, instead of waiting
for all files to be found.
.TP
.B Configuration	
Brings up application configuration dialog.	
.SS
.SS Test Menu
.SS
.TP
.B Reg. Expression	 
Allows a regular expression to be entered, along with sample text as a
way of checking that your expression returns the expected results.
.SS
.SS Window Menu	
.SS
.TP
.B SearchXX	
Allows quick switching between open search
criteria/results windows.
.TP
.B Help Menu	
Description
.TP
.B User Guide	
Brings up this web address from your default browser
.TP
.B Support		
Brings up the searchMonkey support page from
Sourceforge
.TP
.B About	
Brings up a dialog showing version number, license, and author's
email.

.SH  The Toolbar
Can be hidden from the main-menu (view->toolbar). 
.TP
.B New	 
Starts a brand new search (losing previous search history).
.TP
.B Open	
Opens a previously saved search criteria.
.TP
.B Save	
Saves a search criteria (excluding the results).
.TP
.B Save Results	
Saves the results to a custom XML file. Only available when search
complete.
.TP
.B Play	
Start the search.
.TP
.B Stop	
Stop the search. Only available when search in progress.
.TP
.B Print	
Print the search results in a well formatted way.
.TP
.B Forums	
Starts a new browser instance to the searchMonkey Forums

.SH  The Advanced Search Tab
Displayed when Expert User is enabled. 
.TP
.B File Name	 
Type a new regular expression for file name searching.
.TP
.B Containing Text		
Type a new regular expression for (text-only) contents
searching. Disable this field with check button.
.TP
.B Expr. Wizard	
Brings up a regular expression helper dialog. Makes typing new regular
expressions easier.
.TP
.B Look In		
Type a new starting location for search. Disable recurse directories
with check button.
.TP
.B Open/Multi	
Brings up a folder search dialog. Multi allows multiple folders to be
selected for expert searches.
.TP
.B More/Less Than	
Type a file size (in KBytes) to narrow searches to files less-than
and/or more-than specified size.
.TP
.B More/Less Than	
Type a date expression (e.g. dd/mm/yyyy or dd mmm
yyyy) to narrow searches to files modified before and/or after
specified date.
.SH The Options Tab
Available at all times from the main screen. 
.TP
.B Specifies Not Expression	 
Inverts the search i.e. finds
everything except your regular expression. Status bar shows [INV] to
indicate inverted.
.TP
.B Match case	
When disabled allows case insensitive searching of
file names and/or content.
.TP
.B Regular Expression 
When selected allows regular expressions to be used.
.TP
.B DOS Expression	
When selected allows file names to be found using
DOS/Glob style pattern matching i.e. * and ?.
.TP
.B Open/Multi	
Brings up a folder search dialog. Multi allows
multiple folders to be selected for expert searches.
.TP
.B More/Less Than	
Type a file size (in KBytes) to narrow searches to
files less-than and/or more-than specified size.
.TP
.B More/Less Than	
Type a date expression (e.g. dd/mm/yyyy or dd mmm
yyyy) to narrow searches to files modified before and/or after
specified date.

.SH  File Name Results
This pane is only filled when matches are found.
Left clicking on a match will bring up content matches (displayed in
the Context Results pane, if any), and right-clicking the row will
bring up a sub-menu. 
.SS
.SS Right Click Menu
.SS
.TP 
.B Open	 
Opens the file name in your preferred text editor. See configuration.
.TP
.B Copy	
Copies the full file name into the clipboard for use elsewhere.
.TP
.B Delete	
Deletes the selected file forever, once confirmed.
.TP
.B Explore		
Opens your preferred file browser that contains the selected file

.SH  Context Results
This pane is only filled when text matches are found, and a result has
been selected.

The line that matches the search expression will be shown in full, and
the actual match text will be highlighted. Once text has been selected
with the left-button, the right button will allow copy options, or
select-all to be performed on the text. These allow text to be copied
from the results window, and pasted elsewhere. 

.SH  Advanced File Name and/or Contents Searching
To find files, using regular expressions can be achieved by filling
out the File Name and Look In boxes. The starting file name can be
typed, copied or selected by using the Open dialog. To search a single
folder, uncheck the Search Subfolders box.

If you want to find a specific regular expression within a text file,
then fill out the Containing Text box with a regular expression. Note:
significantly less files are shown when Containing Text is added
because binary files are skipped.

For a more specific search, add in min/max file size, and the
after/before modified date (if known).

Once ready, press Play to start the search process.

Results (if any) immediately start appearing in the File name results
table, and once complete the total number of matches is shown in the
status bar

.SH  Status Bar
Describes what is currently going on.

    * Phase 1 searching is the gathering of files that match the
filename, size and modified date criteria.

    * Phase 2 searching is the internal checking of text files to
match the search strings.

    * Upon completion, the number of hits is displayed, along with
whether this was an inverse filename search [inv] or [cancelled] by
the user 

.SH  Tips and Tricks
This section gives examples of some cool things to do with
searchMonkey.
.SS
.SS Regular Expressions
.TP
Some examples of regular expressions are given here:
.TP
.B (\\.[ch])$
Finds all of the C source code, plus headers.
.TP
.B ^(make)
Finds every make file instance.
.TP
.B ^(void function_name)(;)$
Finds a function declaration, as opposed to the definition
.TP
.B \e([a-zA-Z0-9\es]+\e)
Highlights all text within brackets

.SH SearchMonkey User Guide Online
To view the same guide in HTML please visit
<http://searchmonkey.sourceforge.net/index.php/SearchMonkey_User_Guide>

.SH AUTHOR
This manual page was written by Varun Hiremath <varunhiremath@gmail.com>,
for the Debian project (but may be used by others).
